import QtQuick 2.0
import QtMultimedia 5.5
import QmlVlc 0.1


Item {
    objectName: "Project"
    anchors.fill: parent
    focus: true

    property var fontMain: Qt.font({ family: "Arial",  pixelSize: 30});

    Rectangle {
        objectName: "background"
        id: fon
        color: "#000000"
        anchors.fill: parent
    }

    Item {
        objectName: "AfterFinish"
        property string link_type: "layer"
        id: layerAfterFinish
        opacity: 0.0
        anchors.fill: parent
        z: 50

        Text {
            objectName: "Block_BIB"
            property string link_type: "text"
            id: textBIB
            x: 0
            y: 0
            width: 104
            height: 34
            color: "#FFFFFF"
            font: fontMain
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            text: "999"
        }

        Text {
            objectName: "Block_REGION"
            property string link_type: "text"
            id: textRegion
            x: 104
            y: 0
            width: 104
            height: 34
            color: "#FFFFFF"
            font: fontMain
            horizontalAlignment: Text.AlignRight
            verticalAlignment: Text.AlignVCenter
            text: "RGN"
        }

        Text {
            objectName: "Block_NAME"
            property string link_type: "text"
            id: textNAME
            x: 0
            y: 34
            width: 208
            height: 36
            color: "#FFFFFF"
            font: fontMain
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            text: "NAME"
        }

        Text {
            objectName: "Block_RANK"
            property string link_type: "text"
            id: textRANK
            x: 0
            y: 70
            width: 104
            height: 34
            color: "#F4D03F"
            font: fontMain
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            text: "RANK"
        }

        Item {
            id: clockGroup
            x: 104
            y: 70
            width: 104
            height: 34

            Rectangle {
                anchors.fill: parent
                objectName: "Block_TIMER_fon"
                property string link_type: "fon"
                id: clockFon
                color: "#000000"
            }

            Text {
                anchors.fill: parent
                objectName: "Block_TIMER"
                property string link_type: "clock"
                id: clockTIMER
                color: "#7F7F7F"
                font: fontMain
                horizontalAlignment: Text.AlignRight
                verticalAlignment: Text.AlignVCenter
                text: "00:00.0"
            }
        }

        states: [
            State {
                name: "Show"
                PropertyChanges { target: layerAfterFinish; opacity: 1.0 }
            },
            State {
                name: "Hide"
                PropertyChanges { target: layerAfterFinish; opacity: 0.0 }
            }
        ]

    }

    Item {
        objectName: "Picture"
        property string link_type: "layer"
        id: layerPicture
        opacity: 0.0
        anchors.fill: parent
        z: 10

        Image {
            objectName: "Block_PICTURE"
            property string link_type: "picture"
            id: imagePICTURE
            source: "test.jpg"
            anchors.fill: parent
        }

        states: [
            State {
                name: "Show"
                PropertyChanges { target: layerPicture; opacity: 1.0 }
            },
            State {
                name: "Hide"
                PropertyChanges { target: layerPicture; opacity: 0.0 }
            }
        ]
    }

    Item {
        objectName: "Movie"
        property string link_type: "layer"
        id: layerMovie
        opacity: 0.0
        anchors.fill: parent
        z: 20

        MediaPlayer {
            objectName: "Block_MOVIE"
            property string link_type: "movie"
            id: player4Movie
            source: "test.mp4"
            autoPlay: false
            autoLoad: true
            loops: 1
            volume: 1.0
        }

        VideoOutput {
            id: videoOutput4Movie
            source: player4Movie
            anchors.fill: parent
        }

        states: [
            State {
                name: "Show"
                PropertyChanges { target: layerMovie; opacity: 1.0 }
                StateChangeScript {
                    name: "Show"
                    script: player4Movie.play();
                }
            },
            State {
                name: "Hide"
                PropertyChanges { target: layerMovie; opacity: 0.0 }
                StateChangeScript {
                    name: "Hide"
                    script: player4Movie.pause(); // player.stop();
                }
            }
        ]
    }

    Item {
        objectName: "Stream"
        property string link_type: "layer"
        id: layerStream
        opacity: 0.0
        anchors.fill: parent
        z: 30

        VlcPlayer {
            objectName: "Block_STREAM"
            property string link_type: "stream"
            id: player4Stream
            mrl: "udp://@10.169.13.121:20000"
            volume: 1.0
        }

        VlcVideoSurface {
            id: videoOutput4Stream
            source: player4Stream
            anchors.fill: parent
            opacity: 1.0;
        }

        states: [
            State {
                name: "Show"
                PropertyChanges { target: layerStream; opacity: 1.0 }
                PropertyChanges { target: player4Stream; volume: 1.0 }
                StateChangeScript {
                    name: "Show"
                    script: player4Stream.play();
                }
            },
            State {
                name: "Hide"
                PropertyChanges { target: layerStream; opacity: 0.0 }
                PropertyChanges { target: player4Stream; volume: 0.0 }
            }
        ]
    }

    Item {
        objectName: "Live"
        property string link_type: "layer"
        id: layerLive
        opacity: 0.0
        anchors.fill: parent
        z: 40

        Camera {
            objectName: "Block_LIVE"
            property string link_type: "live"
            id: camera4Live
            captureMode: Camera.CaptureViewfinder
            deviceId: "@device:pnp:\\\\?\\usb#vid_046d&pid_0829&mi_00#6&a1326cf&0&0000#{65e8773d-8f56-11d0-a3b9-00a0c9223196}\\global"
        }

        VideoOutput {
            id: videoOutput4Live
            source: camera4Live
            anchors.fill: parent
        }

        states: [
            State {
                name: "Show"
                PropertyChanges { target: layerLive; opacity: 1.0 }
                //StateChangeScript {
                //    name: "Show"
                //    script: camera4Live.play();
                //}
            },
            State {
                name: "Hide"
                PropertyChanges { target: layerLive; opacity: 0.0 }
            }
        ]
    }

    Item {
        objectName: "Table"
        property string link_type: "layer"
        id: layerTable
        opacity: 0.0
        anchors.fill: parent
        z: 50

        Item {
            objectName: "Row_1"
            property string link_type: "row"
            id: row1

            Text {
                objectName: "BIB"
                property string link_type: "text"
                id: textBIB1
                x: 0
                y: 0
                width: 104
                height: 34
                color: "#FFFFFF"
                font: fontMain
                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter
                text: "999"
            }

            Text {
                objectName: "NAME"
                property string link_type: "text"
                id: textName1
                x: 104
                y: 0
                width: 104
                height: 34
                color: "#FFFFFF"
                font: fontMain
                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter
                text: "Name1"
            }
        }

        Item {
            objectName: "Row_2"
            property string link_type: "row"
            id: row2

            Text {
                objectName: "BIB"
                property string link_type: "text"
                id: textBIB2
                x: 0
                y: 34
                width: 104
                height: 34
                color: "#FFFFFF"
                font: fontMain
                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter
                text: "999"
            }

            Text {
                objectName: "NAME"
                property string link_type: "text"
                id: textName2
                x: 104
                y: 34
                width: 104
                height: 34
                color: "#FFFFFF"
                font: fontMain
                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter
                text: "Name1"
            }
        }
    }

    Keys.onPressed: {
        console.log("\nKey Pressed\n");
        if(event.key === Qt.Key_F1) {
            if( layerAfterFinish.state != "Show" )  layerAfterFinish.state = "Show";
            if( layerPicture.state != "Hide" )  layerPicture.state = "Hide";
            if( layerMovie.state != "Hide" )  layerMovie.state = "Hide";
            if( layerLive.state != "Hide" )  layerLive.state = "Hide";
            if( layerStream.state != "Hide" )  layerStream.state = "Hide";
            if( layerTable.state != "Hide" )  layerTable.state = "Hide";
        } else if(event.key === Qt.Key_F2) {
            if( layerAfterFinish.state != "Hide" )  layerAfterFinish.state = "Hide";
            if( layerPicture.state != "Show" )  layerPicture.state = "Show";
            if( layerMovie.state != "Hide" )  layerMovie.state = "Hide";
            if( layerLive.state != "Hide" )  layerLive.state = "Hide";
            if( layerStream.state != "Hide" )  layerStream.state = "Hide";
            if( layerTable.state != "Hide" )  layerTable.state = "Hide";
        } else if(event.key === Qt.Key_F3) {
            if( layerAfterFinish.state != "Hide" )  layerAfterFinish.state = "Hide";
            if( layerPicture.state != "Hide" )  layerPicture.state = "Hide";
            if( layerMovie.state != "Show" )  layerMovie.state = "Show";
            if( layerLive.state != "Hide" )  layerLive.state = "Hide";
            if( layerStream.state != "Hide" )  layerStream.state = "Hide";
            if( layerTable.state != "Hide" )  layerTable.state = "Hide";
        } else if(event.key === Qt.Key_F4) {
            if( layerAfterFinish.state != "Hide" )  layerAfterFinish.state = "Hide";
            if( layerPicture.state != "Hide" )  layerPicture.state = "Hide";
            if( layerMovie.state != "Hide" )  layerMovie.state = "Hide";
            if( layerLive.state != "Show" )  layerLive.state = "Show";
            if( layerStream.state != "Hide" )  layerStream.state = "Hide";
            if( layerTable.state != "Hide" )  layerTable.state = "Hide";
        } else if(event.key === Qt.Key_F5) {
            if( layerAfterFinish.state != "Hide" )  layerAfterFinish.state = "Hide";
            if( layerPicture.state != "Hide" )  layerPicture.state = "Hide";
            if( layerMovie.state != "Hide" )  layerMovie.state = "Hide";
            if( layerLive.state != "Hide" )  layerLive.state = "Hide";
            if( layerStream.state != "Show" )  layerStream.state = "Show";
            if( layerTable.state != "Hide" )  layerTable.state = "Hide";
        } else if(event.key === Qt.Key_F6) {
            if( layerAfterFinish.state != "Hide" )  layerAfterFinish.state = "Hide";
            if( layerPicture.state != "Hide" )  layerPicture.state = "Hide";
            if( layerMovie.state != "Hide" )  layerMovie.state = "Hide";
            if( layerLive.state != "Hide" )  layerLive.state = "Hide";
            if( layerStream.state != "Hide" )  layerStream.state = "Hide";
            if( layerTable.state != "Show" )  layerTable.state = "Show";
        } else if(event.key === Qt.Key_Escape) {
            if( layerAfterFinish.state != "Hide" )  layerAfterFinish.state = "Hide";
            if( layerPicture.state != "Hide" )  layerPicture.state = "Hide";
            if( layerMovie.state != "Hide" )  layerMovie.state = "Hide";
            if( layerLive.state != "Hide" )  layerLive.state = "Hide";
            if( layerStream.state != "Hide" )  layerStream.state = "Hide";
            if( layerTable.state != "Hide" )  layerTable.state = "Hide";
        }
    }
}
